
char  stick[5];
char  flag[5];

/*..........................................................................................*/
/* haveTap() - check joypads to see if we have a multi-tap connected.                       */
/*..........................................................................................*/

haveTap()
{
	/*.........................................................................*/
	/* wait long enough for all the pads to be read.                           */
	/*.........................................................................*/

	vsync( 5 );

    /*.........................................................................*/
	/* read pad 0 and save value.                                              */
	/*.........................................................................*/
	
#asm
	lda		joy
	sta		_stick
#endasm

	/*.........................................................................*/
	/* see if all the pads match pad 0. If they do, thee's no tap connected.   */
	/*.........................................................................*/
	
#asm

  ldy      #1				; start with pad 1
  
  ;------------------------------------------------------------------------
  ; does this pad match pad 0 ?

.check
  lda		joy,y
  sta		_stick,y
  
  cmp       joy
  beq		.next	  	   	; they match, keep checking
  
  ;------------------------------------------------------------------------
  ; they don't match. we have a tap

  lda		#0
  sta		_flag,y
  
  ldx		#1
  cla
  bra		.out
  
  ;------------------------------------------------------------------------
  ; they matched. check next

.next  

  lda		#1
  sta		_flag,y
  
  iny		
  cpy		#5
  bne		.check
  
  ;------------------------------------------------------------------------
  ; we ran out of sticks.
  
  cla
  clx

.out  
#endasm
}
