/*------------------------------------------------------------------------------------*/
/* printMsg.c - functions for 'typewriting' text to the screen...                     */
/*------------------------------------------------------------------------------------*/

#define   WIDTH_CHARS     63

/** Used to do title scroll text **/
#define   BLINK_DELAY      3
#define   TYPE_DELAY       5          /* every 30 frames print a char */


int   charDelay;
int   blinkDelay;

int   curChar;
int   maxChars;

/*....................................................................................*/
/* text scren position, in ( 8x8 ) character cells.                                   */
/*....................................................................................*/

int  textX;
int  textY;

const char msg[3] = 
{
   "INTERFACE WITH ABCARD PROTOTYPE$\n",
   "EXECUTE BYTE CYCLES V0$5$$$\n",
   "LAUNCH HUMAN VS$ HUMAN SIM$$$\n$\n$$\n$$$\n$$$$\n$$$$$\n$$$$$$\n$$$$$$$\n$$$$$$$$*"
};

/*------------------------------------------------------------------------------------*/
/* printNextChar() - print next character of mesage to screen, after suitable delay.  */
/*------------------------------------------------------------------------------------*/

printNextChar()
{

    /*.............................................................*/
    /* If there are more chars to print, go ahead and do them.     */
    /*.............................................................*/
    
    if( curChar < maxChars )
    {
       /*......................................................*/
       /* if the typing delay is done, print another character */
       /*......................................................*/
       
       charDelay--;
       if( charDelay < 0 )
       {
          if( msg[curChar] == '*' )
          {
             return;
          }
          /*................................................................*/
          /* reset cursor at EOL.                                           */
          /*................................................................*/

          if( msg[curChar] == '\n' )
          {
             textY++;
             textX = 0;
          }
          /*................................................................*/
          /* or print the character.                                        */
          /*................................................................*/
          else
          {
             put_char( msg[curChar], textX, textY );
             textX++;
          }
          
          /*.................................................................*/
          /* move to next character, update cursor location.                 */
          /*.................................................................*/
          
          curChar++;

          /*................................................................*/
          /* if off edge, move down a line and reset.                       */
          /*................................................................*/
          
          if( textX > WIDTH_CHARS )
          {
             textY ++;
             textX = 0;
          }
          /*................................................................*/
          /* reset typing delay.                                            */
          /*................................................................*/
          
          charDelay = TYPE_DELAY;
		  psgSStop(25);
		  psgPlay(25);
		  psgSStop(25);
       }
    }
}