/****************************************************************************************/
/* Racer4.c - functions and data for racer #4                                           */
/*--------------------------------------------------------------------------------------*/

#define  P4_START_X        85
#define  P4_START_Y        40

int  p4x[TRAIL_LENGTH];
int  p4y[TRAIL_LENGTH];

int  p4QueueOldest;
int  p4QueueNewest;
int  p4CurDirection;
int  p4NewDirection;

int  p4Speed;

/*......................................................................................*/
/* player 1 temp variables.                                                             */
/*......................................................................................*/

int   p4Index;
int   p4NextNewest;
int   p4NextOldest;
int   p4CheckX;
int   p4CheckY;
int   p4HitColor;

/*--------------------------------------------------------------------------------------*/
/* initp4() - initialize player # 4.                                                    */
/*--------------------------------------------------------------------------------------*/

initP4()
{
	/*........................................................................*/
	/* initialize screen location.                                            */
	/*........................................................................*/  

	p4x[0] = p4x[1] = P4_START_X;
	p4y[0] = p4y[1] = P4_START_Y;
	
	p4CurDirection  = MOVE_DOWN;
    p4Speed         = SP_MEDIUM;
	
	/*........................................................................*/
	/* initialize queue pointers.                                             */
	/*........................................................................*/
	
	p4QueueOldest = 0;
	p4QueueNewest = 1;

	/*........................................................................*/
	/* initialize sprite location.                                            */
	/*........................................................................*/

	spr_set( 3 );
	spr_x( p4x[p4QueueNewest] );
	spr_y( p4y[p4QueueNewest] );
  
}
/*--------------------------------------------------------------------------------------*/
/* p4UpdateSprite() - update player 2 sprite location.                                  */
/*--------------------------------------------------------------------------------------*/

p4UpdateSprite()
{
	spr_set( 4 );
	
	/*........................................................................*/
	/* Directions.                                                            */
	/*........................................................................*/

	if( p4CurDirection == MOVE_UP    )  
	{
		spr_ctrl( FLIP_MAS, 0);
		spr_pattern( 0x0C00 + bike[3] * 128 );
		spr_x( p4x[p4QueueNewest] - 8);
		spr_y( p4y[p4QueueNewest] - 4);
	}
	if( p4CurDirection == MOVE_DOWN  )
	{
		spr_ctrl( FLIP_MAS, FLIP_Y );
		spr_pattern( 0x0C00 + bike[3] * 128 );
		spr_x( p4x[p4QueueNewest] - 8);
		spr_y( p4y[p4QueueNewest] - 4);
	}
	if( p4CurDirection == MOVE_RIGHT )
	{
		spr_ctrl( FLIP_MAS, 0 );
		spr_pattern( 0x0C00 + bike[3] * 128 + 0x40);
		spr_x( p4x[p4QueueNewest] - 4);
		spr_y( p4y[p4QueueNewest] - 8);
	}
	if( p4CurDirection == MOVE_LEFT  )
	{
		spr_ctrl( FLIP_MAS, FLIP_X );
		spr_pattern( 0x0C00 + bike[3] * 128 + 0x40 );
		spr_x( p4x[p4QueueNewest] - 4);
		spr_y( p4y[p4QueueNewest] - 8);
	}
}

/*--------------------------------------------------------------------------------------*/
/* p4CheckCollision() - check for player 2 collision.                                   */
/*--------------------------------------------------------------------------------------*/

p4CheckCollision()
{
    p4CheckX = p4x[ p4QueueNewest ] + DeltaX[ p4CurDirection ];
	p4CheckY = p4y[ p4QueueNewest ] + DeltaY[ p4CurDirection ];
	
	for( p4Index = 1; p4Index <= p4Speed; p4Index ++ )
	{
		p4CheckX = p4CheckX + DeltaX[ p4CurDirection ];
		p4CheckY = p4CheckY + DeltaY[ p4CurDirection ];
		
		if( gfx_point( p4CheckX, p4CheckY ) != 0 ) 
		{
		   return( 1 );
		}
    }
	return( 0 );
}
/*--------------------------------------------------------------------------------------*/
/* p4UpdateTrail() - update player twos trail; this updates the endpont que as well.    */
/*--------------------------------------------------------------------------------------*/

p4UpdateTrail()
{
	p4NewDirection = p4GetDirection();
	if( p4NewDirection != p4CurDirection )
	{
        /*..........................................................................*/
		/* if line array is full, erase oldest line.                                */
		/*..........................................................................*/
		
        if( p4QueueFull() )
		{
		    p4NextOldest = p4QNextOldest();
			p4EraseTrail();
		    p4QueueOldest = p4NextOldest;
		}
		
        /*..........................................................................*/
        /* add new line to line array.                                              */
        /*..........................................................................*/

		p4NextNewest = p4QNextNewest( p4QueueNewest );

		p4x[p4NextNewest] = p4x[p4QueueNewest];
		p4y[p4NextNewest] = p4y[p4QueueNewest];
		p4QueueNewest     = p4NextNewest;
		p4CurDirection    = p4NewDirection;
    }
}
/*--------------------------------------------------------------------------------------*/
/* p4DrawTrail() - draw trail for player 2.                                             */
/*--------------------------------------------------------------------------------------*/

p4DrawTrail()
{
	if( p4CurDirection == MOVE_UP    )  
	{
		gfx_line( p4x[p4QueueNewest], 
				  p4y[p4QueueNewest],
				  p4x[p4QueueNewest] + DeltaX[ p4CurDirection] * p4Speed, 
				  p4y[p4QueueNewest] + DeltaY[ p4CurDirection] * p4Speed, 11 );
				  
		gfx_line( p4x[p4QueueNewest] - 1, 
				  p4y[p4QueueNewest],
				  p4x[p4QueueNewest] - 1 + DeltaX[ p4CurDirection] * p4Speed, 
				  p4y[p4QueueNewest]     + DeltaY[ p4CurDirection] * p4Speed, 11 );
    }
	if( p4CurDirection == MOVE_DOWN    )  
	{
		gfx_line( p4x[p4QueueNewest], 
				  p4y[p4QueueNewest],
				  p4x[p4QueueNewest] + DeltaX[ p4CurDirection] * p4Speed, 
				  p4y[p4QueueNewest] + DeltaY[ p4CurDirection] * p4Speed, 11 );
				  
		gfx_line( p4x[p4QueueNewest] - 1, 
				  p4y[p4QueueNewest],
				  p4x[p4QueueNewest] - 1 + DeltaX[ p4CurDirection] * p4Speed, 
				  p4y[p4QueueNewest]     + DeltaY[ p4CurDirection] * p4Speed, 11 );
    }

	if( p4CurDirection == MOVE_LEFT    )  
	{
		gfx_line( p4x[p4QueueNewest], 
				  p4y[p4QueueNewest],
				  p4x[p4QueueNewest] + DeltaX[ p4CurDirection] * p4Speed, 
				  p4y[p4QueueNewest] + DeltaY[ p4CurDirection] * p4Speed, 11 );
				  
		gfx_line( p4x[p4QueueNewest],
				  p4y[p4QueueNewest] -1,
				  p4x[p4QueueNewest]    + DeltaX[ p4CurDirection] * p4Speed, 
				  p4y[p4QueueNewest] -1 + DeltaY[ p4CurDirection] * p4Speed, 11 );
    }
	if( p4CurDirection == MOVE_RIGHT    )  
	{
		gfx_line( p4x[p4QueueNewest], 
				  p4y[p4QueueNewest],
				  p4x[p4QueueNewest] + DeltaX[ p4CurDirection] * p4Speed, 
				  p4y[p4QueueNewest] + DeltaY[ p4CurDirection] * p4Speed, 11 );
				  
		gfx_line( p4x[p4QueueNewest], 
				  p4y[p4QueueNewest] - 1,
				  p4x[p4QueueNewest]     + DeltaX[ p4CurDirection] * p4Speed, 
				  p4y[p4QueueNewest] - 1 + DeltaY[ p4CurDirection] * p4Speed, 11 );
    }

}
/*--------------------------------------------------------------------------------------*/
/* p4EraseTrail() - erase first trail in queue.                                         */
/* note: this relys on ous not having turned yet.                                       */
/*--------------------------------------------------------------------------------------*/

p4EraseTrail()
{
    p4NextOldest = p4QNextOldest();
		
	if( p4x[p4QueueOldest] == p4x[p4NextOldest]    )
	{
		gfx_line( p4x[p4QueueOldest], p4y[p4QueueOldest],
				  p4x[p4NextOldest ], p4y[p4NextOldest ], 0 );
				  
		gfx_line( p4x[p4QueueOldest] - 1, p4y[p4QueueOldest],
				  p4x[p4NextOldest ] - 1, p4y[p4NextOldest ], 0 );
    }
	if( p4y[p4QueueOldest] == p4y[p4NextOldest]    )
	{
		gfx_line( p4x[p4QueueOldest], p4y[p4QueueOldest],
				  p4x[p4NextOldest ], p4y[p4NextOldest ], 0 );
				  
		gfx_line( p4x[p4QueueOldest], p4y[p4QueueOldest] - 1,
				  p4x[p4NextOldest ], p4y[p4NextOldest ] - 1, 0 );
    }

}
/*--------------------------------------------------------------------------------------*/
/* p4UpdateDeath() - update player 4 sprite location.                                  */
/*--------------------------------------------------------------------------------------*/

p4UpdateDeath()
{
	spr_set( 4 );
	
	/*........................................................................*/
	/* Directions.                                                            */
	/*........................................................................*/
	if(frame % 4 == 0)	
	{
		spr_pattern( ExplodeAddress );
	}
	else
	{
		
		if(frame % 3 == 0) 
		{
			spr_ctrl(FLIP_MAS, FLIP_X);
			spr_pattern(ExplodeAddress + 0x40);
		}
		else if(frame % 2 == 0)
		{
			spr_ctrl(FLIP_MAS, FLIP_Y);
			spr_pattern(ExplodeAddress + 0x40);
		}
		else
		{
			spr_ctrl(FLIP_MAS, 0);
			spr_pattern(ExplodeAddress + 0x40);
		}	
	}
	
	
	if( p4CurDirection == MOVE_UP    )  
	{
		spr_x( p4x[p4QueueNewest] - 8);
		spr_y( p4y[p4QueueNewest] - 4);
	}
	if( p4CurDirection == MOVE_DOWN  )
	{
		spr_x( p4x[p4QueueNewest] - 8);
		spr_y( p4y[p4QueueNewest] - 4);
	}
	if( p4CurDirection == MOVE_RIGHT )
	{
		spr_x( p4x[p4QueueNewest] - 4);
		spr_y( p4y[p4QueueNewest] - 8);
	}
	if( p4CurDirection == MOVE_LEFT  )
	{
		spr_x( p4x[p4QueueNewest] - 4);
		spr_y( p4y[p4QueueNewest] - 8);
	}
}
