/*......................................................................................*/
/* Titlecr.c - functions for handling title screen for Massteroids.                     */
/*......................................................................................*/

int  runPressed;

char humans;
char n_ready;

/*......................................................................................*/
/* runMainTitle() - run main title screen.                                              */
/*......................................................................................*/

runMainTitle()
{
    /*.........................................................................*/
	/* wait for all joypads to be read. 5 frames is enough, even if 1 pad is   */
	/* is read each frame.                                                     */
    /*.........................................................................*/

    vsync(0);
	satb_update();
	
    /*.........................................................................*/
	/* start music.                                                            */
    /*.........................................................................*/

	psgPlay(MENU_SONG);
}
/*......................................................................................*/
/* runOnePlayerMenu() - run single player menu.                                         */
/*......................................................................................*/

runOnePlayerMenu()
{
   cls();
   put_string( "Single Player", 10, 0 );
   
   put_string( "   All Alone   ", 10, 15 );
   put_string( "Versus Computer", 10, 16 );

   /*......................................................................*/
   /* wait until RUN released.                                             */
   /*......................................................................*/
   
   while( joyRunDown( 0 ) )
   {
	  vsync(0);
	  if( psgMStat() == 0 )
	  {
		 psgPlay( MENU_SONG );
	  }
   }
   /*......................................................................*/
   /* wait for run to be pressed again.                                    */
   /*......................................................................*/
   
   while( !joyRunPressed( 0 ) )
   {
	  vsync(0);
	  if( psgMStat() == 0 )
	  {
		 psgPlay( MENU_SONG );
	  }
   }
   humans = 1;
   n_ready = 1;
}
/*......................................................................................*/
/* runMultiPlayerMenu() - run Multi-player menu.                                        */
/*......................................................................................*/

runMultiPlayerMenu()
{
   int  i;
   
   cls();
   put_string( "Multi-Player", 10, 0 );

   shipPositionIcons();
   
   /*......................................................................*/
   /* wait until RUN released.                                             */
   /*......................................................................*/
   
   while( joyRunDown( 0 ) )
   {
	  vsync(0);
	  if( psgMStat() == 0 )
	  {
		 psgPlay( MENU_SONG );
	  }
   }
   put_string( "Press I  to Join",  8, 16 );

   /*......................................................................*/
   /* loop until everyone active presses [RUN]                             */
   /*......................................................................*/
   
   while( 1 )
   {
	   vsync(0);
	   if( psgMStat() == 0 )
	   {
	 	 psgPlay( MENU_SONG );
	   }
       satb_update();
	  
 	   #asm
	   stz		_humans
	   stz		_n_ready
	   #endasm
	   
       /*...............................................................*/
	   /* check all the sticks.                                         */
	   /*...............................................................*/
	   
	   for( i = 0; i < MAX_SHIPS; i ++ )
	   {
	      /*.........................................................*/
		  /* toggle active bit if button I pressed.                  */
		  /*.........................................................*/
		  
	      if( joy_I_Pressed( i ) )
		  {
		     if( ShipState[ i ] & SHIP_ACTIVE )
			 {
			    ShipState[ i ] = ShipState[i] & SHIP_INACTIVE;
			 }
			 else
			 {
			    ShipState[ i ] = ShipState[i] | SHIP_ACTIVE;
			 }
		  }
	      /*...........................................................*/
		  /* if this ship is active, display ON indicator and count it */
	      /*...........................................................*/
		  
		  if( ShipState[i] & SHIP_ACTIVE )
		  {
	         spr_show(   ShipSpriteNo + i   );
			 humans++;
			 
			 /*..........................................................*/
			 /* since this ship is active, check to see if player ready. */
			 /*..........................................................*/
			 
			 if( joyRunDown( i ) )
			 {
			   n_ready++;
			 }
		  }
		  else
		  {
	         spr_hide(   ShipSpriteNo + i   );
		  }
	   }   
	   /*......................................................................*/
	   /* We've checked all the sticks. Make sure we have at least one player, */
	   /* and if so, see if everyone active is ready.                          */
	   /*......................................................................*/
	   
	   if( humans >= 1 )
	   {
	       put_string( "Hold RUN to Start", 8, 17 );
		   if( n_ready == humans )
		   {
			  return;
		   }
	   }
	   else
	   {
	      put_string( "                 ", 8, 17 );
	   }
	   
       if( joySelectReleased( 0 ) ) reboot();

   }
}