/**********************************************************************************/
/* SpawnRock() - spawn new rock.                                                  */
/*................................................................................*/

SpawnRock()
{
    /*.......................................................................*/
	/* initialize master sprite variables.                                   */
    /*.......................................................................*/

	#asm
	ldx		_spawnIndex			; select rock
	
	lda		_spawnType
	sta		_RockType,x
	
	lda		#1
	sta		_RockDelay,x		; initial delay is 1
	
    lda		_spawnH
    sta		_RockHeading,x		; set initial heading

    ;--------------------------------------------------------
    ; save spawn coordinates as current coordinates
	
	lda		_spawnX
	sta     _RockScreenXl, x
	lda		_spawnX+1
	sta		_RockScreenXh, x
	stz		_RockScreenXf,x
	
	lda		_spawnY
	sta		_RockScreenYl, x
	lda		_spawnY+1
	sta		_RockScreenYh,x
	stz		_RockScreenYf,x
	
    ;--------------------------------------------------------
	; look up delta values for current heading
	
	ldy     _RockHeading, x
	
	lda		_cosf,y
	sta	    _RockDeltaXf, x
	lda     _cosl,y
	sta	    _RockDeltaXl, x
	lda     _cosh,y
	sta     _RockDeltaXh, x
	
	lda		_sinf,y
	sta	    _RockDeltaYf, x
	lda     _sinl,y
	sta	    _RockDeltaYl, x
	lda     _sinh,y
	sta     _RockDeltaYh, x
	
    ;--------------------------------------------------------
	; mark rock as active; it's not quite complete, but doing
	; it here means we don't have to re-load index.
	
	lda		#1
	sta		_RockActive,x
	
    ;--------------------------------------------------------
	; now we set the graphics address. these are ints, so we
	; need to fix the indexes
    
	lda     _RockType,x			; get rock type
	asl		a					; 2 bytes for address
	tay							; Y -> address offset
	
	txa							; get rock number
	asl		a					; 2 bytes for address
	tax							; X -> Where to Save Address
	
    ;--------------------------------------------------------
    ; save rock graphics address
	
	clc
	lda     _address,y
	adc		#LOW( _RockAddress )
	sta		_RockCurrentAddress,x
	
	lda		_address+1,y
	adc		#HIGH( _RockAddress )
	sta		_RockCurrentAddress+1,x
	
	#endasm
}
/**********************************************************************************/
/* SetupRockSprite() - initialize rock sprite.                                    */
/*................................................................................*/
/* this needs converted to assembler, as soon as I figure out how to do calls.    */
/*................................................................................*/

SetupRockSprite()
{
    /************************************************************************/
	/* select sprite to initialize.                                         */
	/*......................................................................*/
	
	spr_set( FIRST_ROCK + spawnIndex );

    /*................................................................*/
	/* initialize sprite to 8x8 size.                                 */
	/*................................................................*/
	
	spr_ctrl( SIZE_MAS, sizeMask[ RockType[ spawnIndex ] ]  );
    spr_pattern( RockCurrentAddress[ spawnIndex ]  );
	
    /*................................................................*/
	/* set initial sprite coordinates.                                */
    /*................................................................*/

	spr_x( RockScreenXh[ spawnIndex ] * 256 + RockScreenXl[ spawnIndex ] 
	     - RockSpriteOffset[ RockType[ spawnIndex ] ]                    );
	spr_y( RockScreenYh[ spawnIndex ] * 256 + RockScreenYl[ spawnIndex ] 
	     - RockSpriteOffset[ RockType[ spawnIndex ] ]                    );
	
	spr_pal(     RockPaletteNo + 16	);
	spr_pri( 0 );
    spr_show( FIRST_ROCK + spawnIndex  );
}