/***************************************************************************/
/* splitRock() - split rock into 2 parts.                                  */
/*-------------------------------------------------------------------------*/
splitRock()
{
/*
   put_string( "Split",     0, 2 );
   put_number( rock_no, 4,  5, 2 );
   put_number( RockType[ rock_no ], 4, 10, 2 );
   WaitForButtonB();
*/
   
#asm
    ;------------------------------------------------------------------
	; get rock type in x

	ldx		_rock_no				; get rock number into X
	lda		_RockType,x				; load type

    ;------------------------------------------------------------------
	; ignore right half, for now
	
	cmp		#5
	bne		.split_it
	rts
.split_it	

    ;------------------------------------------------------------------
    ; this is a try to go through table.
    ; it doesn't work, so we probably have the wrong page mapped.
	; so, how do we force them into same page ?
    ;..................................................................
    ; apparently, putting them in this file will put them in the same
	; page as this code; that -could- change if the code requires a 
	; page split.
	
	asl		a
    tax
    jmp		[splitTab,x]
    rts
	
    ;------------------------------------------------------------------
	; the jump table.
	
splitTab
    .dw     _r0Split
	.dw		_r8Split
	.dw     _r16Split
	.dw		_r32Split
	.dw		_r64Split
#endasm
}

/**********************************************************************************/
/* r64Split() - split 64x64 sprite into 2 32x32 sprites.                          */
/*................................................................................*/

r64Split()
{
    #asm
	ldx		_rock_no

	lda		_RockScreenXl,x
	sta		_spawnX
	lda		_RockScreenXh,x
	sta		_spawnX+1

	lda		_RockScreenYl,x
	sta		_spawnY
	lda		_RockScreenYh,x
	sta		_spawnY+1
	
	#endasm
	

    /*.......................................................................*/
	/* spawn rock 1 at heading - 1.                                          */
    /*.......................................................................*/
	
    spawnType = ROCK_32X32;
    spawnIndex = rock_no + 4;
    spawnH     = (RockHeading[ rock_no ] - 1) & 0x07;
	SpawnRock();
	SetupRockSprite();
	
    /*.......................................................................*/
	/* spawn rock 2 at heading - 45.                                         */
    /*.......................................................................*/
	
    spawnIndex = rock_no;
    spawnH     = (RockHeading[ rock_no ] + 1) & 0x07;
    SpawnRock();
	SetupRockSprite();
}
/**********************************************************************************/
/* r32Split() - split 32x32 sprite into 2 16x16 sprites.                         */
/*................................................................................*/

r32Split()
{
    #asm
	ldx		_rock_no

	lda		_RockScreenXl,x
	sta		_spawnX
	lda		_RockScreenXh,x
	sta		_spawnX+1

	lda		_RockScreenYl,x
	sta		_spawnY
	lda		_RockScreenYh,x
	sta		_spawnY+1
	
	#endasm

    /*.......................................................................*/
	/* spawn rock 1 at heading - 1.                                          */
    /*.......................................................................*/
	
    spawnType = ROCK_16X16;
    spawnIndex = rock_no + 2;
    spawnH     = (RockHeading[ rock_no ] - 1) & 0x07;
	SpawnRock();
	SetupRockSprite();
	
    /*.......................................................................*/
	/* spawn rock 2 at heading + 1.                                          */
    /*.......................................................................*/
	
    spawnIndex = rock_no;
    spawnH     = (RockHeading[ rock_no ] + 1) & 0x07;
    SpawnRock();
	SetupRockSprite();
}
/**********************************************************************************/
/* r16Split() - split 16x16 sprite into 2 8x8 sprites.                            */
/*................................................................................*/

r16Split()
{
    #asm
	ldx		_rock_no

	lda		_RockScreenXl,x
	sta		_spawnX
	lda		_RockScreenXh,x
	sta		_spawnX+1

	lda		_RockScreenYl,x
	sta		_spawnY
	lda		_RockScreenYh,x
	sta		_spawnY+1
	
	#endasm

    /*.......................................................................*/
	/* spawn rock 1 at heading - 1.                                          */
    /*.......................................................................*/
	
    spawnType = ROCK_8X8;
    spawnIndex = rock_no + 1;
    spawnH     = (RockHeading[ rock_no ] - 1) & 0x07;
	SpawnRock();
	SetupRockSprite();
	
    /*.......................................................................*/
	/* spawn rock 2 at heading + 1.                                          */
    /*.......................................................................*/
	
    spawnIndex = rock_no;
    spawnH     = (RockHeading[ rock_no ] + 1) & 0x07;
    SpawnRock();
	SetupRockSprite();
}

/**********************************************************************************/
/* r8Split() - get rid of 8x8 sprite.                                             */
/*................................................................................*/

r8Split( )
{
	#asm
	ldx		_rock_no
	stz		_RockActive,x
	#endasm
    spr_hide( FIRST_ROCK + rock_no     );
}
/**********************************************************************************/
/* r0Split() - bad index routine.                                                 */
/*................................................................................*/

r0Split( )
{
/*
    put_string( "Bad Index", 0, 0 );
	WaitForButtonB();
*/
}
