/*........................................................................................*/
/* cmpHiScore() - compare current score to high score.                                    */
/*........................................................................................*/

cmpHiScore()
{
#asm

    lda    #low(_HiScore)         ; high score address in AX
	sta    _ax
	lda    #high( _HiScore)
	sta    _ax+1
	
    lda    #low(_CurScore)          ; current score address in BX
	sta    _bx
	lda    #high( _CurScore)
	sta    _bx+1

	jsr    cmp_scores               ; compare them
	
#endasm
}
/*........................................................................................*/
/* cmpScore() - compare the score at [AX] to the score at [BX].                           */
/*               return -1, 0, or 1 depending on whether [AX] is <, =, or > [BX].         */
/*........................................................................................*/
/* Note: this is meant to be called only from other assembly routines, sinc AX and BX     */
/* need to be set up first.                                                               */
/*........................................................................................*/

cmpScore()
{
#asm

scoreBytes   =  4                 ; needs to be same as #define above
   
  
;===========================================================================   
; check single byte of high score against same byte of current score.
;---------------------------------------------------------------------------

cmp_scores:

   ldy   #scoreBytes-1    ; byte offset - lowest is at 0

hs_loop:
   lda   [_bx],y           ; get score 2 byte
   cmp   [_ax],y       ; check against score 1 byte
   
   beq   do_next          ; if same, keep trucking
   bcc   hs_low           ; if <, return -1
   
;-----------------------------------------------------------------------------
; curScore < HiScore.
;-----------------------------------------------------------------------------
   
   lda   #$00
   ldx   #$01
   jmp   sc1_out
   
;-----------------------------------------------------------------------------
; curScore > HiScore.
;-----------------------------------------------------------------------------

hs_low
   lda   #$ff
   ldx   #$ff
   jmp   sc1_out
   
;-----------------------------------------------------------------------------
; curScore == hiScore (so far)
; loop and do next byte.
;-----------------------------------------------------------------------------

do_next:
   dey
   bpl  hs_loop
   
   lda  #$0            ; return hi
   ldx  #$0            ; return low
   
sc1_out:
#endasm
}
