/***************************************************************************/
/* Ship.h - header file for ship data.                                     */
/*-------------------------------------------------------------------------*/
/* TIMING functions. Color is G B R, so ships are red.                     */
/*.........................................................................*/

#define SHIP_TRACE_ON	  	set_color( 256, 0007 );
#define SHIP_TRACE_OFF	 	set_color( 256, 0000 );

/*.........................................................................*/

#define  MAX_SHIPS                  4
#define  SHIP_MAX_VELOCITY          8
#define  SHIP_MIN_VELOCITY         -8
#define  SHIP_EXPLODE_DELAY         4
#define  SHIP_SPAWN_DELAY          90

#define  INITIAL_SHIPS              3

#asm
_SHIP_MAX_VELOCITY  =  4
_SHIP_MIN_VELOCITY  = -4

_MAX_SHIPS  = 4
#endasm

/*.........................................................................*/
/* ship states.                                                            */
/*.........................................................................*/

#define  SHIP_ALIVE                  0x01
#define  SHIP_DYING                  0x02
#define  SHIP_DEAD                   0x04

#define  SHIP_PLAYER                 0x40
#define  SHIP_ACTIVE                 0x80

#define  SHIP_INACTIVE               0x7f
#asm
_SHIP_ALIVE = $01
_SHIP_DYING = $02
#endasm

/*.........................................................................*/
/* ship initial position data.                                             */
/*.........................................................................*/
/*                                     TL    BR   TR  BL                   */

const char shipInitXh[ MAX_SHIPS ] = {  0,    0,   0,  0  };
const char shipInitXl[ MAX_SHIPS ] = { 32,  224, 224, 32  };

const char shipInitYh[ MAX_SHIPS ] = {  0,    0,   0,   0  };
const char shipInitYl[ MAX_SHIPS ] = { 32,  200,  32, 200  };

const char shipInitHeading[ MAX_SHIPS ] = { 7, 3, 5, 1 };

/*.........................................................................*/
/* number of ships currently in use by players.                            */
/*.........................................................................*/

/*.........................................................................*/
/* ship coordinates.                                                       */
/*.........................................................................*/

char  ShipScreenXf[ MAX_SHIPS ];
char  ShipScreenXl[ MAX_SHIPS ];
char  ShipScreenXh[ MAX_SHIPS ];       /* center of ship; use -7/+8 for corners */

char  ShipScreenYf[ MAX_SHIPS ];
char  ShipScreenYh[ MAX_SHIPS ];
char  ShipScreenYl[ MAX_SHIPS ];

char  ShipHeading[ MAX_SHIPS ];

char  ShipDeltaXh[ MAX_SHIPS ];
char  ShipDeltaXl[ MAX_SHIPS ];
char  ShipDeltaXf[ MAX_SHIPS ];

char  ShipDeltaYh[ MAX_SHIPS ];
char  ShipDeltaYl[ MAX_SHIPS ];
char  ShipDeltaYf[ MAX_SHIPS ];

char  ShipThrusting[ MAX_SHIPS ];
char  ShipState[     MAX_SHIPS ];
char  ShipLeft[      MAX_SHIPS ];

/*.....................................................................................*/
/* hero animation information.                                                         */
/*.....................................................................................*/

int   ShipCurrentAddress[ MAX_SHIPS ];
char  ShipFrame[          MAX_SHIPS ];
char  ShipFrameDelay[     MAX_SHIPS ];

/*.....................................................................................*/
/* shots controlled by this ship.                                                      */
/*.....................................................................................*/

int   ShipFirstShot[ MAX_SHIPS ];
int   ShipLastShot[  MAX_SHIPS ];

char  ShotsFired[ MAX_SHIPS ];

/*.....................................................................................*/
/* storage for assembler ship number.                                                  */
/*.....................................................................................*/

char  ship_no;
char  ship_heading;

char  trig[4];
